<?php
	//SCRIPT PARA LA CONSULTA DE LA BASE DE DATOS DEL PADRON MUNICIPAL
	//AUTOR: SANTIAGO DE LA PARTE FLOREZ
	
	//parmetros de conexin
	$DBHOST = "localhost";
	$DBNAME = "padron";
	$DBUSER = "padron";
	$DBPASS = "xLRKba6CvBw2CW4y";

	//comprobamos que los datos POST existen y fueron recibidos correctamente
	if (isset($_POST['tipo'])) {
		$conn = new PDO("mysql:host=".$DBHOST.";dbname=".$DBNAME,$DBUSER,$DBPASS);
		if (!$conn) {
			echo "Error";
			die();
		}

		$sql = "";
		$vars = array();
		$nvars = 0;
		$cond = "WHERE ";
		$groupby = "";

		//calculamos el numero de variables
		if (isset($_POST['sex'])) {
			$nvars++;
		}
		if (isset($_POST['nac'])) {
			$nvars++;
		}
		if (isset($_POST['extr'])) {
			$nvars++;
		}
		if (isset($_POST['esp'])) {
			$nvars++;
		}
		if (isset($_POST['est'])) {
			$nvars++;
		}
		if (isset($_POST['edad'])) {
			$nvars++;
		}
		if (isset($_POST['dto'])) {
			$nvars++;
		}
		if (isset($_POST['sec'])) {
			$nvars++;
		}
		if (isset($_POST['zona'])) {
			$nvars++;
		}

		//construimos la consulta en funcion del tipo de dato solicitado y de los
		//parametros recibidos
		switch ($_POST['tipo']) {
		case "count":
			$sql = "SELECT COUNT(*) AS TOTAL FROM PADRON_HABITANTES";
			break;
		case "sexo":
			$sql = "SELECT SEX.SEXO AS RESULTADO, COUNT(*) AS TOTAL FROM (";
			for ($i = 1; $i<=$nvars; $i++) {
				$sql = $sql."(";
			}
			if (isset($_POST['edad'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['dto'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['sec'])) {
				$sql = substr($sql,0,-1);
			}
			$sql = $sql."PADRON_HABITANTES PAD INNER JOIN CODIGO_SEXO SEX ON PAD.ID_SEXO = SEX.ID) ";
			$groupby = "GROUP BY RESULTADO";
			break;
		case "estudios":
			$sql = "SELECT EST.ESTUDIOS_INE AS RESULTADO, COUNT(*) AS TOTAL FROM (";
			for ($i = 1; $i<=$nvars; $i++) {
				$sql = $sql."(";
			}
			if (isset($_POST['edad'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['dto'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['sec'])) {
				$sql = substr($sql,0,-1);
			}
			$sql = $sql."PADRON_HABITANTES PAD INNER JOIN CODIGO_ESTUDIOS EST ON PAD.ID_ESTUDIOS = EST.ID) ";
			$groupby = "GROUP BY RESULTADO";
			break;
		case "edad":
		$sql = "SELECT PAD.EDAD AS RESULTADO, SEX.SEXO AS SEXO, COUNT(*) AS TOTAL FROM (";
			for ($i = 1; $i<=$nvars; $i++) {
				$sql = $sql."(";
			}
			if (isset($_POST['edad'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['dto'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['sec'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['sex'])) {
				$sql = substr($sql,0,-1);
			}
			$sql = $sql."PADRON_HABITANTES PAD INNER JOIN CODIGO_SEXO SEX ON PAD.ID_SEXO = SEX.ID) ";
			$groupby = "GROUP BY RESULTADO, SEXO";
			break;
		case "nacional":
			$sql = "SELECT CAU.COM_AUTON AS RESULTADO, COUNT(*) AS TOTAL FROM ((";
			for ($i = 1; $i<=$nvars; $i++) {
				$sql = $sql."(";
			}
			if (isset($_POST['edad'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['dto'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['sec'])) {
				$sql = substr($sql,0,-1);
			}
			$sql = $sql."PADRON_HABITANTES PAD INNER JOIN CODIGO_PROVINCIA PRV ON PAD.ID_PROVINCIA_NAC = PRV.ID) " . 
				"INNER JOIN CODIGO_COM_AUTON CAU ON PRV.ID_COM_AUTON = CAU.ID) ";
			$groupby = "GROUP BY RESULTADO";
			break;
		case "extranjero":
			$sql = "SELECT PAI.COD_CONTINENTE AS RESULTADO, COUNT(*) AS TOTAL FROM (";
			for ($i = 1; $i<=$nvars; $i++) {
				$sql = $sql."(";
			}
			if (isset($_POST['edad'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['dto'])) {
				$sql = substr($sql,0,-1);
			}
			if (isset($_POST['sec'])) {
				$sql = substr($sql,0,-1);
			}
			$sql = $sql."PADRON_HABITANTES PAD INNER JOIN CODIGO_PAIS PAI ON PAD.ID_NACIONALIDAD = PAI.ID) ";
			$groupby = "GROUP BY RESULTADO";
			break;
		}

		if ( isset($_POST['sex']) and strcmp($_POST['tipo'],"edad")!=0 ) {
			$sql = $sql . "INNER JOIN CODIGO_SEXO SEX ON PAD.ID_SEXO = SEX.ID) ";
		}
		if (isset($_POST['nac'])) {
			$sql = $sql . "INNER JOIN (CODIGO_PROVINCIA PRV INNER JOIN CODIGO_COM_AUTON CAU ON PRV.ID_COM_AUTON = CAU.ID) " .
				"ON PAD.ID_PROVINCIA_NAC = PRV.ID) ";
		}
		if (isset($_POST['extr'])) {
			$sql = $sql . "INNER JOIN CODIGO_PAIS PAI ON PAD.ID_NACIONALIDAD = PAI.ID) ";
		}
		if (isset($_POST['esp'])) {
			$sql = $sql . "INNER JOIN CODIGO_PROVINCIA PRV ON PAD.ID_PROVINCIA_NAC = PRV.ID) ";
		}
		if (isset($_POST['est'])) {
			$sql = $sql . "INNER JOIN CODIGO_ESTUDIOS EST ON PAD.ID_ESTUDIOS = EST.ID) ";
		}
		if (isset($_POST['zona'])) {
			$sql = $sql . "INNER JOIN CODIGO_DTO_SECCION ZON ON (PAD.DISTRITO = ZON.DISTRITO AND PAD.SECCION = ZON.SECCION)) ";
		}

		if (strcmp($_POST['tipo'],"extranjero") == 0) {
			$sql = $sql . $cond . "PAI.PAIS <> 'Espaa' ";
			$cond = "AND ";
		}
		if (isset($_POST['dto'])) {
			$sql = $sql . $cond . "PAD.DISTRITO = ? ";
			$vars[] = $_POST['dto'];
			$cond = "AND ";
		}
		if (isset($_POST['sec'])) {
			$sql = $sql . $cond . "PAD.SECCION = ? ";
			$vars[] = $_POST['sec'];
			$cond = "AND ";
		}
		if (isset($_POST['zona'])) {
			$sql = $sql . $cond . "ZON.ZONA_ESTADISTICA = ? ";
			$vars[] = $_POST['zona'];
			$cond = "AND ";
		}
		if (isset($_POST['edad'])) {
			$miEdad = $_POST['edad'];
			$pos = strpos($miEdad," ");
			if ($pos === FALSE) {
				$sql = $sql . $cond . "PAD.EDAD BETWEEN ? AND ? ";
				$otraPos = strpos($miEdad,"-");
				if ($otraPos == 1) {
					$vars[] = substr($miEdad, 0, 1);
				} else {
					$vars[] = substr($miEdad, 0, 2);
				}
				$vars[] = substr($miEdad, ($otraPos+1));
			} else {
				$sql = $sql . $cond . "PAD.EDAD >= ? ";
				$vars[] = substr($miEdad, ($pos+1));
			}
			$cond = "AND ";
		}
		if (isset($_POST['sex'])) {
			$sql = $sql . $cond . "SEX.SEXO = ? ";
			$vars[] = $_POST['sex'];
			$cond = "AND ";
		}
		if (isset($_POST['est'])) {
			$sql = $sql . $cond . "EST.CODIGO_INE = ? ";
			$vars[] = $_POST['est'];
			$cond = "AND ";
		}
		if (isset($_POST['esp'])) {
			$sql = $sql . $cond . "PRV.PROVINCIA <> 'Extranjero' AND PRV.PROVINCIA <> 'Desconocida' ";
			$cond = "AND ";
		}
		if (isset($_POST['nac'])) {
			$sql = $sql . $cond . "CAU.COD_COM_AUTON = ? ";
			$vars[] = $_POST['nac'];
			$cond = "AND ";
		}
		if (isset($_POST['extr'])) {
			if (strcmp($_POST['extr'],'EURO') == 0) {
				$sql = $sql . $cond . "PAI.PAIS <> 'Espaa' AND ";
			} else {
				$sql = $sql . $cond;
			}
			$sql = $sql . "PAI.COD_CONTINENTE = ? ";
			$vars[] = $_POST['extr'];
			$cond = "AND ";
		}

		//ejecutamos la consulta
		$sql = $sql . $groupby;
		$stmt = $conn->prepare($sql);
		$stmt->execute($vars);
		
		//mostramos el resultado dividiendo los campos con # y las lneas con @
		switch ($_POST['tipo']) {
		case "count":
			while($row = $stmt->fetch(PDO::FETCH_ASSOC)){
				echo $row['TOTAL']."@";
			}
			break;
		case "edad":
			while($row = $stmt->fetch(PDO::FETCH_ASSOC)){
				echo $row['RESULTADO']."#".$row['SEXO']."#".$row['TOTAL']."@";
			}
			break;
		default:
			while($row = $stmt->fetch(PDO::FETCH_ASSOC)){
				echo $row['RESULTADO']."#".$row['TOTAL']."@";
			}
			break;
		}

		//Cierro la conexin
		$conn = NULL;
	} else {
		echo "Error: No existen datos";
	}
?> 
